// Characters to int/long conversion functions

// Convert given Char (0-9/a-f/A-F) to number (from 0-15)
unsigned char mj_convert_hex_nibble(unsigned char c) {
  unsigned int num = 0;
  if (c >= '0' && c <= '9') {
    num = c - '0';
  } else {
    if (c >= 'a' && c <= 'f') {
      num = c - 'a' + 10;
    } else if (c >= 'A' && c <= 'F') {
      num = c - 'A' + 10;
    }
  }
  return (num);
}

// Convert given 2 Chars to number 0-255
unsigned char mj_convert_hex_char(char c1, char c2) {
  return ((mj_convert_hex_nibble(c1) << 4) + mj_convert_hex_nibble(c2));
}

// Convert given 4 Chars to number 0-65535
unsigned int mj_convert_hex_int(char c1, char c2, char c3, char c4) {
  return ((unsigned int) (mj_convert_hex_nibble(c1) << 12) + (unsigned int) (mj_convert_hex_nibble(c2) << 8) + (unsigned int) (mj_convert_hex_nibble(c3) << 4) + (unsigned int) mj_convert_hex_nibble(c4) );
}

// Converts a given Hex-String (up to 8 chars) to unsigned long
unsigned long mj_convert_hex_long(char *c) {
  int i;
  unsigned long num = 0;
  // We convert maximal 8 characters as a unsigned long has maximal 8 hex digits
  for (i = 0; i < 8 && c[i]; i++) {
    num <<= 4;
    num += mj_convert_hex_nibble(c[i]);
  }
  return (num);
}

// Converts a given Decimal-String (up to 10 chars) to unsigned long
unsigned long mj_convert_dec_long(char *c) {
  int i;
  unsigned long num = 0;
  // We convert maximal 10 characters as a unsigned long has maximal 10 decimal digits
  for (i = 0; i < 10 && c[i]; i++) {
    num *= 10;
    if (c[i] >= '0' && c[i] <= '9') {
      num += (c[i] - '0');
    } else {
      num = 0;
      break;
    }
  }
  return (num);
}
